<template>
  <section>
    <div class="progress-wrapper">
      <value
        class="progress-completed"
        :value="closedIssues / target"
        :max="600"
      />
      <template v-if="isOngoing">
        <value
          class="progress-assigned"
          :value="assignedIssues / target"
          :max="600"
        />
        <value
          class="progress-ready"
          :value="readyIssues / target"
          :max="600"
        />
        <value class="progress-open" :value="openIssues / target" :max="600" />
        <value
          v-if="missingIssues > 0"
          class="progress-gap"
          :value="missingIssues / target"
          :max="600"
        />
        <value
          v-if="missingIssues === 0"
          class="progress-total"
          :value="totalIssues / target"
        />
      </template>
      <div class="progress-target" :style="{ left: 600 }" />
    </div>
    <table>
      <tbody>
        <tr>
          <td></td>
          <td class="text-align-right">
            <strong>{{ target }}</strong>
          </td>
          <td>Target: completed migrations this quarter</td>
        </tr>
        <tr v-if="isOngoing" class="border-top">
          <td></td>
          <td class="text-align-right">{{ totalIssues - openIssues }}</td>
          <td>migration issues, that are done, assigned or ready:</td>
        </tr>
        <tr>
          <td><span class="progress-completed legend"></span></td>
          <td class="text-align-right">{{ closedIssues }}</td>
          <td>closed issues</td>
        </tr>
        <template v-if="isOngoing">
          <tr>
            <td><span class="progress-assigned legend"></span></td>
            <td class="text-align-right">{{ assignedIssues }}</td>
            <td>assigned Issues</td>
          </tr>
          <tr>
            <td><span class="progress-ready legend"></span></td>
            <td class="text-align-right">{{ readyIssues }}</td>
            <td>"ready to be worked" on issues</td>
          </tr>
          <tr class="border-top">
            <td><span class="progress-open legend"></span></td>
            <td class="text-align-right">{{ openIssues }}</td>
            <td>open issues <i>without</i> migration instructions</td>
          </tr>
          <tr v-if="missingIssues > 0">
            <td><span class="progress-gap legend"></span></td>
            <td class="text-align-right">
              {{ missingIssues }}
            </td>
            <td>
              "missing" issues. Issues that still need to be created (and get
              migration instructions)
            </td>
          </tr>
          <tr v-if="ignoredIssues > 0">
            <td><span class=""></span></td>
            <td class="text-align-right">
              {{ ignoredIssues }}
            </td>
            <td>
              "ignored" issues. Issues that have <em>wontfix</em> or
              <em>meta</em> labels.
            </td>
          </tr>
        </template>
      </tbody>
    </table>
  </section>
</template>
<script>
import Value from "./Value.vue";
import { ISSUE_STATES, ONGOING } from "../../lib/constants";

export default {
  name: "overall-stats",
  components: { Value },
  props: {
    status: {},
    target: {},
    total: {},
  },
  computed: {
    isOngoing() {
      return this.status === ONGOING;
    },
    assignedIssues() {
      return this.total[ISSUE_STATES.ASSIGNED] || 0;
    },
    readyIssues() {
      return this.total[ISSUE_STATES.READY_TO_BE_IMPLEMENTED] || 0;
    },
    closedIssues() {
      return this.total[ISSUE_STATES.CLOSED] || 0;
    },
    openIssues() {
      return this.total[ISSUE_STATES.OPEN] || 0;
    },
    ignoredIssues() {
      return this.total[ISSUE_STATES.IGNORED] || 0;
    },
    totalIssues() {
      return (
        this.closedIssues +
        this.readyIssues +
        this.openIssues +
        this.assignedIssues
      );
    },
    missingIssues() {
      return this.status === "ONGOING"
        ? Math.max(0, this.target - this.totalIssues)
        : 0;
    },
  },
};
</script>
<style scoped>
td {
  line-height: 24px;
  padding: 4px 2px;
}
.legend {
  height: 24px;
  width: 24px;
  display: inline-block;
}

.border-top td {
  border-top: 1px solid black;
}

.text-align-right {
  text-align: right;
}
</style>
